那些数据对于云来说风险太大?
======

![](https://opensource.com/sites/default/files/styles/image-full-size/public/lead-images/rh_003499_01_cloud21x_cc.png?itok=5UwC92dO)

在这个由四部分组成的系列文章中，我们一直在关注每个组织在将操作转换到云时应避免的陷阱 - 特别是混合多云环境。
在第一部分中，我们介绍了基本定义以及我们对混合云和多云的看法，确保显示两者之间的分界线。 在第二部分中，我们讨论了三个陷阱中的第一个：为什么成本并不总是成为迁移到云的明显动力。 而且，在第三部分中，我们研究了将所有工作负载迁移到云的可行性。
最后，在第四部分中，我们将研究如何处理云中的数据。 您应该将数据移动到云中吗？ 多少？ 什么数据在云中起作用，是什么造成移动风险太大？

### 数据... 数据... 数据...
影响您对云中数据的所有决策的关键因素是确定您的带宽和存储需求。 Gartner预计“数据存储将在2018年成为[1730亿美元] [4]业务”，其中大部分资金浪费在不必要的容量上：“全球公司只需优化工作量就可以节省620亿美元的IT成本。” 根据Gartner的研究，令人惊讶的是，公司“为云服务平均支付的费用比他们实际需要的多36％”。
如果您已经阅读了本系列的前三篇文章，那么您不应该对此感到惊讶。 然而，令人惊讶的是，Gartner的结论是，“如果他们将服务器数据直接转移到云上，只有25％的公司会省钱。”
等一下......工作负载可以针对云进行优化，但只有一小部分公司会通过将数据迁移到云来节省资金吗？ 这是什么意思？
如果您认为云提供商通常会根据带宽收取费率，那么将所有内部部署数据移至云中很快就会成为成本负担。 有三种情况，公司决定将数据放入云中是值得的：
  
  具有存储和应用程序的单个云
  
  云中的应用程序，内部存储
  
  云中的应用程序和缓存在云中的数据，以及内部存储


在第一种情况下，通过将所有内容保留在单个云供应商中来降低带宽成本。 但是，这会产生锁定，这通常与CIO的云战略或风险防范计划相悖。
第二种方案仅保留应用程序在云中收集的数据，并将最小值传输到本地存储。 这需要仔细考虑的策略，其中只有使用最少数据的应用程序部署在云中。
在第三种情况下，数据缓存在云中，应用程序和存储的数据，或存储在内部的“一个事实”。 这意味着分析，人工智能和机器学习可以在内部运行，而无需将数据上传到云提供商，然后在处理后再返回。 缓存数据仅基于应用程序需求，甚至可以跨多云部署进行缓存。

要获得更多信息，请下载红帽[案例研究] [5]，其中描述了跨混合多云环境的阿姆斯特丹史基浦机场数据，云和部署策略。
### 数据危险
大多数公司都认识到他们的数据是他们在市场上的专有优势，智能能力。 因此，他们非常仔细地考虑了它的储存地点。
想象一下这种情况：你是一个零售商，全球十大零售商之一。 您已经计划了一段时间的云战略，并决定使用亚马逊的云服务。 突然，[亚马逊购买了Whole Foods] [6]并且正在进入你的市场。
一夜之间，亚马逊已经增长到零售规模的50％。 您是否信任其零售数据的云？ 如果您的数据已经在亚马逊云中，您会怎么做？ 您是否使用退出策略创建了云计划？ 虽然亚马逊可能永远不会利用您的数据的潜在见解 - 该公司甚至有针对此的协议 - 你能相信今天世界上任何人的话吗？
### 陷阱分享，避免陷阱
分享我们在经验中看到的一些陷阱应该有助于您的公司规划更安全，更安全，更持久的云战略。 了解[成本不是明显的激励因素] [2]，[并非一切都应该在云中] [3]，并且您必须在云中有效地管理数据才是您成功的关键。
--------------------------------------------------------------------------------

via: https://opensource.com/article/18/8/data-risky-cloud

作者：[Eric D.Schabell][a]
选题：[lujun9972](https://github.com/lujun9972)
译者：[geekmar](https://github.com/geekmar)
校对：[geekmar](https://github.com/geekmar)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/eschabell
[1]:https://opensource.com/article/18/4/pitfalls-hybrid-multi-cloud
[2]:https://opensource.com/article/18/6/reasons-move-to-cloud
[3]:https://opensource.com/article/18/7/why-you-cant-move-everything-cloud
[4]:http://www.businessinsider.com/companies-waste-62-billion-on-the-cloud-by-paying-for-storage-they-dont-need-according-to-a-report-2017-11
[5]:https://www.redhat.com/en/resources/amsterdam-airport-schiphol-case-study
[6]:https://www.forbes.com/sites/ciocentral/2017/06/23/amazon-buys-whole-foods-now-what-the-story-behind-the-story/#33e9cc6be898
